<template>
  <i-wrapper top>
    <i-header :title="$t(`Date and time of birth`)" back />
    <i-curtain tag="form" :bottom-circles="false" fixed @submit="save()">
      <div class="container d-flex flex-column align-items-center">
        <img src="~assets/images/bubbles-orange.svg" class="bubbles p-bubbles" />
        <img src="~assets/images/scientist-cake.png" class="p-scientist" />
        <div class="p-title">{{ $t(`Date of birth`) }}</div>
        <div class="p-description">
          {{ $t(`When's your birthday? A person's date of birth is the foundation of any astrological prediction.`) }}
        </div>
        <i-input
          ref="birthDateInput"
          v-model="birthDate"
          type="date"
          class="p-birth-date-input"
          :placeholder="$t(`Enter your birthday`)"
          :flow="['year', 'month', 'date']" />
        <i-input
          ref="birthTimeInput"
          v-model="birthTime"
          type="time"
          class="p-birth-time-input"
          :placeholder="$t(`Type the time of birth`)"
          :flow="['time']" />
        <i-checkbox v-model="dontRememberTime" :label="$t(`I don't remember the time`)" class="p-checkbox" />
      </div>
      <template #bottom>
        <i-button submit block :loading="isLoading" :disabled="isLoading">{{ $t(`Save`) }}</i-button>
      </template>
    </i-curtain>
  </i-wrapper>
</template>

<script>
  export default {
    layout: 'default',
    nuxtI18n: false,
    middleware: ['logged-in-only'],
    transition: { name: 'fade', mode: 'out-in' },

    data() {
      return {
        birthDate: this.$store.state.auth.user.birthDate,
        birthTime: this.$store.state.auth.user.birthTime,
        dontRememberTime: !this.$store.state.auth.user.birthTime,
        isLoading: false,
      };
    },

    watch: {
      birthTime() {
        if (this.birthTime) {
          if (this.dontRememberTime) {
            this.dontRememberTime = false;
          }
        } else {
          if (!this.dontRememberTime) {
            this.dontRememberTime = true;
          }
        }
      },

      dontRememberTime() {
        if (this.dontRememberTime) {
          if (this.birthTime) {
            this.birthTime = null;
          }
        } else {
          if (!this.birthTime) {
            this.$refs.birthTimeInput.$refs.root.querySelector('.i-input__input').focus();
          }
        }
      },
    },

    methods: {
      async save() {
        this.isLoading = true;

        try {
          let response = await this.$axios.post('users/me/update', {
            user: {
              birthDate: this.birthDate.split('T')[0],
              birthTime: this.birthTime ? this.birthTime.split('T')[1].split('.')[0] : null,
            },
          });

          this.$store.commit('MERGE_AUTH', { user: response.data.data });
          this.$router.go(-1);
        } catch (error) {
          this.isLoading = false;
          throw error;
        }
      },
    },
  };
</script>

<style lang="scss" scoped>
  .p-bubbles {
    top: rs(147px);
  }

  .p-scientist {
    width: rs(112px);
    margin-top: rs(48px);
  }

  .p-title {
    font-size: rf(20px);
    color: #575167;
    font-weight: bold;
    margin-top: rs(4px);
  }

  .p-description {
    font-size: rf(16px);
    color: #575167;
    text-align: center;
    margin-top: rs(5px);
  }

  .p-birth-date-input {
    margin-top: rs(50px);
  }

  .p-birth-time-input {
    margin-top: rs(24px);
  }

  .p-checkbox {
    width: 100%;
    margin-top: rs(24px);
  }
</style>
